#!/usr/bin/perl
# Copyright: Binny V Abraham 2003-2004                                       #
# If you want to use this script, Leave this message here                    #
##############################################################################
# Website: http://binnyva.tripod.com                                         #
# E-Mail : binnyva@rediffmail.com                                            #
# Get more Perl scripts from http://binnyva.tripod.com/code/perl             #
##############################################################################
# Name : HTMLViewer                                                          #
# Version : 1.02.A                                                           #
# This is a offline HTML file viewer for DOS. Run the script with the html   #
# file in the command line. For best results, use the Batch file 'html.bat'  #
##############################################################################

# Take the file to be opened from the command line
if(@ARGV)
 {
 $file = $ARGV[0]; 
 }
# If no command line, exit.
else
 {
 print "Usage: html <filename>\n\n";# [<options>]
 exit(0);
 }

# Opens the said file for reading
open(FILE,"$file") || print "Can't open $file: $!\n";
@LINES=<FILE>;
close(FILE);
$SIZE=@LINES;

# Initializes all the variables
$title_flag = 0;
$body_flag = 0;
$title = "";
$body = "";
$pre_line = 0;

# Reads the file line by line
for($i=0;$i<=$SIZE;$i++)
 {
 $_=$LINES[$i];
 if(/.*<title>.*/gi)    #To take the title.
  {  
  if($_ =~ /.*<title>(.*)<\/title>.*/gi)
   {
   $title=$1;
   }
  else
   {
   my $j=$i;
   while(!$title_flag) 
    {
    $title .= $LINES[$j];
    if(/.*<\/title>.*/gi) { $title_flag=1; }
    $j++;
    $_ = $LINES[$j];
    }
   }
  }#End of if(/.*<title>.*/gi)
   
 if(/.*<body.*/gi)     #To take the contents of the body.
  {
  my $k=$i;
  $body_start_line=$i;  
  while(!$body_flag)
   {
   $body .= $LINES[$k];
   if(/.*<pre>.*/i) { $pre_line = $k;} # If there is a <pre> tag in the body, mark the line number  
   if(/.*<\/body>.*/gi)
    { 
    $body_flag=1;
    $body_end_line=$k;
    }
   $k++;
   $_=$LINES[$k];
   }
  }#End of if(/.*<body.*/gi)
 }#End of for($i=0;$i<=$SIZE;$i++)
 
if($title =~ /.*<title>(.*)<\/title>.*/) { $title = $1; }

# This will remove take all content from <pre>-</pre> to a variable $pre
while($pre_line)
 {
 $pre .= $LINES[$pre_line];
 $pre_line++;
 $_=$LINES[$pre_line];
 if(/.*<\/pre>.*/gi) { $pre_line=0; }
 }

# Substitues all \n with <br> to be substitued later on.
$pre =~ s/<.*>//gi;
$pre =~ s/\n/<br>/gi;

$body =~ s/<pre[^<]*>(.*)<\/pre>/$pre/si;

# All nessary substitution to make HTML text.
$body =~ s/>\n/>/g;
$body =~ s/\n/ /g;
$body =~ s/  / /g; #Replace unnessary spaces
$body =~ s/  / /g;
# Tag Specific Replacments
$body =~ s/<p align\=.center.>(.*)<\/P>/\n        $1\n/gi;
$body =~ s/<p>/\n\n/gi;
$body =~ s/<\/p>//gi;
$body =~ s/<br>/\n/gi;

# Smart Replaces
# [^<] - Will take anything other that '<'.This will ensure that no other tags will be replaced as the tag start charector(<) won't be accepted. 
$body =~ s/<img[^<]*alt=([^<]*)[^<]*>/[-IMAGE-$1]/gi;    #<img > with Alt Text
$body =~ s/<img[^<]*>/[-IMAGE-]/gi;                      #<img > without Alt Text
$body =~ s/<h1.*align=.center..*>(.*)<\/h1>/             $1\n\n/gi;
$body =~ s/<h([1-6])[^<]*>([^<]*)<\/h[1-6]>/\n-$2-\n/gi; #The Headings substitions. Finds text with '<h' and a number and extracts the info within the '>' and '<' in such a way that no tags get taken.
$body =~ s/<a[^<]*>([^<]*)<\/a>/[-LINK-$1]/gi;           #<a > Substitution

$body =~ s/<\/font>//gi;     #</font>
$body =~ s/<font [^<]*>//gi; #<font >
$body =~ s/<.?ol>/\n/gi;    # For the lists Ordered and Unordered
$body =~ s/<li>/\n    /gi; #
$body =~ s/<div[^<]*>([^<]*)<\/div>/$1/gi;
$body =~ s/<span[^<]*>([^<]*)<\/span>/$1/gi;
$body =~ s/<!--.*-->//gmi; # Html Comments

# Unsupported tags support
# Tables
$body =~ s/<tr[^<]*>/\n/gi;
$body =~ s/<\/table>/\n/gi;
# Scripts
$body =~ s/<script[^<]*>[^<]*<\/script>//gi;

$body =~ s/<.?i>//gi;
$body =~ s/<.?b>//gi;
$body =~ s/<.?u>//gi;
$body =~ s/<[^<]*>//gi;

#Other char substitution
$body =~ s/&quot;/\"/g;
$body =~ s/&nbsp;/ /g;

###########################################################################################
  
#Print the whole thing
print "-------------------------------------------------------------------------------\n";
print "File : $file || Title : $title";
print "\n-------------------------------------------------------------------------------\n";
print "$body";
print "\n-------------------------------------------------------------------------------\n";


########
# TO DO
########
# More than 1 pre tags are not supported
# No Support for tables
# Put some more explanations for that Regular Expession Usage. It is super complex.